      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8)
      * ---------------------------------------------------------------
      * Module.: TG0001_M02           Project.....:
      * Author.: A. Campin            Date written: 06/06/2008
      * Purpose: Screen Two. Get Trigger Control Data.
      * ---------------------------------------------------------------
      * Called by: TG0001_M01
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
      *                  Standards
      *                  Function Keys.
      *
      *  F3  - SAA Exit.
      *  F12 - Previous Screen.
      * ---------------------------------------------------------------
      *                       Indicators
      *
      * @@@ Indicators 1 - 25 for data base I/O.
      *
      *      01 - I/O to ___
      *
      * @@@ Indicators 26 - 29 for subfile control.
      *
      *      26 - Display subfile control.
      *      27 - Display subfile.
      *      28 - Clear subfile.
      *      29 - SFLEND enabled.
      *
      * @@@ Indicators 30 - 49 display file I/O control.
      *
      *      30 - I/O to ___.
      *
      * @@@ Indicators 50 - 79 field error indicators.
      *
      * @@@ Indicators 80 - 94 Condition control.
      *
      * @@@ Indicators 95 - 99 Scratch indicators.
      *
      *      95 - Subfile message handler.
      *      99 - Scratch indicator.
      * ---------------------------------------------------------------
     h NoMain
     h Option(*Srcstmt:*Nodebugio)

     fTG0001_D01cf   e             WorkStn InfDs(g_dsFileInformation01)
     f                                     UsrOpn
     f                                     InDDS(dsIndicators)
     f                                     Include(RD01_02  :
     f                                             SFMSG_CTL)

      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,xvmsgf_pr
      /copy *libl/qsrcf,xvuspc_pr
      /copy *libl/qsrcf,tg0001_lp

     d LoadScreenFields...
     d                 pr

     d ValidInput...
     d                 pr                  Like(StdLgl)

     d Update...
     d                 pr                  Like(StdLgl)

     d LoadTriggerHeader...
     d                 pr

     d g_dsFileInformation01...
     d                 ds                  Qualified
     d   KeyPressed...
     d                       369    369

     d g_dsSystem...
     d                sds           333    Qualified
     d   ModuleName...
     d                         1     10
     d   UserName...
     d                       254    263

      /copy *libl/qsrcf,CB_MAP_IND
     d DisplaySubfileEndOnSubfileMessageQueue...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN95)
      *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*
      * Data Structure for Trigger Control Header. Mapped to User Space
      *  TG_CTRL_HDR.
     d g_dsTriggerHeader...
     d               e ds                  Qualified
     d                                     ExtName(TGCTRLH)
     d                                     Based(ptrTriggerHeader)

      /copy *libl/qsrcf,CB_KEYP

     d cMainProcedureName...
     d                 c                   Const('PROCESSSCREEN02')
     d cUserSpaceLibrary...
     d                 c                   'TRIGGERM'

     d g_ProgramName...
     d                 s                   Like(StdNam)
     d                                     Import

     d g_ScreenOpen...
     d                 s                   Like(StdLgl)
     d                                     Inz(cFalse)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ProcessScreen02
      *   Do Processing for Screen 2 - Standard Input Panel.
      *   Input     - None
      *   Out       - None.
      *   Returns   - Key Pressed.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ProcessScreen02...
     p                 b                   Export
     d                 pi                  like(StdChr)
      /Free

       If Not g_ScreenOpen;
         g_ScreenOpen = cTrue;
         Open TG0001_D01;
       EndIf;

       // If trigger header not loaded, call function to load.
       If ptrTriggerHeader = *Null;
         LoadTriggerHeader();
       EndIf;

       LoadScreenFields();

       MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                     g_dsSystem.ModuleName:
                                     g_ProgramName        );
       DoU 0 = 1;

         // Display subfile messages.
         DisplaySubfileEndOnSubfileMessageQueue = cTrue;
         SFM_C_PGMQ = '*';
         Write SFMSG_CTL;

         ExFmt RD01_02;

         MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                       g_dsSystem.ModuleName:
                                       g_ProgramName        );
         Clear ErrorIndicators;

         Select;
           When g_dsFileInformation01.KeyPressed = F3 or
                g_dsFileInformation01.KeyPressed = F12;
              Return g_dsFileInformation01.KeyPressed;
           Other;
             If Not ValidInput();
               Iter;
             EndIf;

             If Not Update();
               Iter;
             EndIf;

             Return Enter;
         EndSl;
       EndDo;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * CloseScreen02
      *   Closeout Screen 02.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p CloseScreen02...
     p                 b                   Export
     d                 pi
      /Free

       If %Open(TG0001_D01);
         Close TG0001_D01;
         g_ScreenOpen = cFalse;
       EndIf;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadScreenFields
      *   Load screen fields.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadScreenFields...
     p                 b
     d                 pi
      /Free

       B_ACTIVE = g_dsTriggerHeader.THACTIVE;
       B_RELOAD = cNo;

       O_LASTDATE = %Char(%Date(g_dsTriggerHeader.THRELOADTS):*USA/);
       O_LASTTIME = %Char(%Time(g_dsTriggerHeader.THRELOADTS):*HMS:);
       O_LASTUSER = g_dsTriggerHeader.THRELOADUS;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ValidInput
      *   Validate Input Fields.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - Valid input. True or False.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ValidInput...
     p                 b
     d                 pi                  Like(StdLgl)
      /Free

       Return cTrue;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * Update
      *   Do update of data base.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - Valid input. True or False.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p Update...
     p                 b
     d                 pi                  Like(StdLgl)
      /Free

       g_dsTriggerHeader.THACTIVE   = B_ACTIVE;
       g_dsTriggerHeader.THRELOADUS = g_dsSystem.UserName;
       If B_RELOAD = cYes;
         B_RELOAD   = cNo;
         g_dsTriggerHeader.THRELOADTS = %TimeStamp();
         MSGF_SendProgramMessage('UTG0001'            :
                                 cXVMessageFileName   :
                                 ' '                  :
                                 cMainProcedureName   :
                                 g_dsSystem.ModuleName:
                                 g_ProgramName        );

         // Force screen to redisplay.
         Return cFalse;
       EndIf;

       Return cTrue;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadTriggerHeader
      *   Function load trigger header. If header is not found, creates the
      *     user space and initializes it.
      *   Input     - None.
      *   Out       - None.
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadTriggerHeader...
     p                 b
     d                 pi
      /Free

       Monitor;
         ptrTriggerHeader = USPC_GetPointerToUserSpace('TG_CTRL_HD':
                                                       '*LIBL'     );
       On-Error;
         USPC_CreateUserSpace('TG_CTRL_HD'            :
                              cUserSpaceLibrary       :
                              %Size(g_dsTriggerHeader):
                              cFalse                  :  // Extendable
                              'Trigger Control Header':
                              '*USE'                  :  // Authority
                              '*NO'                   :  // Replace existing
                              1                       :  // Paging
                              '1'                     ); // Optimize space alignment

         ptrTriggerHeader = USPC_GetPointerToUserSpace('TG_CTRL_HD':
                                                       '*LIBL'     );

         g_dsTriggerHeader.THACTIVE   = cNo;
         g_dsTriggerHeader.THRELOADTS = %TimeStamp();
         g_dsTriggerHeader.THRELOADUS = g_dsSystem.UserName;
       EndMon;

       Return;

      /End-Free
     p                 e
