      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTSQLRPGI OBJ(@5/@4) +
      *_>   SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   OBJTYPE(*MODULE) COMMIT(*NONE) OPTION(*EVENTF) +
      *_>   DBGVIEW(*SOURCE) CLOSQLCSR(*ENDMOD) +
      *_>   TOSRCFILE(@2/QSQLTEMP1)
      * ---------------------------------------------------------------
      * Module.: TG0001_M03           Project.....:
      * Author.: A. Campin            Date written: 06/06/2008
      * Purpose: Maintain Detail Trigger Control Records.
      * ---------------------------------------------------------------
      * Called by: TG0001_M02
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
      *                  Standards
      *                  Function Keys.
      *
      *  F3  - SAA Exit.
      *  F5  - Reload Screen.
      *  F6  - Add Record.
      *  F12 - Previous Screen.
      * ---------------------------------------------------------------
      *                       Indicators
      *
      * @@@ Indicators 1 - 25 for data base I/O.
      *
      * @@@ Indicators 26 - 29 for subfile control.
      *
      *      26 - Display subfile control.
      *      27 - Display subfile.
      *      28 - Clear subfile.
      *      29 - SFLEND enabled.
      *
      * @@@ Indicators 30 - 49 display file I/O control.
      *
      * @@@ Indicators 50 - 79 field error indicators.
      *
      * @@@ Indicators 80 - 94 Condition control.
      *
      * @@@ Indicators 95 - 99 Scratch indicators.
      *
      *      95 - Subfile message handler.
      *      99 - Scratch indicator.
      * ---------------------------------------------------------------
     h NoMain
     h Option(*Srcstmt:*Nodebugio)

     fTG0001_D01cf   e             WorkStn InfDs(g_dsFileInformation01)
     f                                     Sfile(RD01_03S             :
     f                                           g_SubfileRecordNumber)
     f                                     UsrOpn
     f                                     InDDS(dsIndicators)
     f                                     Include(RD01_03S :
     f                                             RD01_03C :
     f                                             RD01_03O :
     f                                             SF_BLANK :
     f                                             SFMSG_CTL)

      /copy *libl/qsrcf,cb_std_con
      /copy *libl/qsrcf,cb_stdtype
      /copy *libl/qsrcf,xvmsgf_pr
      /copy *libl/qsrcf,xverrh_pr
      /copy *libl/qsrcf,xvuspc_pr
      /copy *libl/qsrcf,tg0001_lp

     d LoadSubfile...
     d                 pr

     d ClearSubfile...
     d                 pr

     d LoadOnePage...
     d                 pr                  Like(StdNam)

     d LoadPreviousPage...
     d                 pr

     d WriteSubfileRecord...
     d                 pr
     d  PR_InRecordNumber...
     d                                     Like(StdInt)
     d                                     Value

     d GetSelectedRecords...
     d                 pr                  Like(StdChr)

     d BuildIOUserSpace...
     d                 pr

      /copy *libl/qsrcf,CB_MAP_IND
     d DisplaySubfileControl...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN26)
     d DisplaySubfile...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN27)
     d ClearSubfileInd...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN28)
     d DisplaySubfileEnd...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN29)
     d SubfileNextChanged...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN86)
     d PositionToChanged...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIN89)
     d DisplaySubfileEndOnSubfileMessageQueue...
     d                                     Like(StdLgl)
     d                                     Overlay(GenericIn95)

      * File Information Display File 01.
     d g_dsFileInformation01...
     d                 ds                  Qualified
     d   KeyPressed...
     d                       369    369

     d g_dsSystem...
     d                sds           333    Qualified
     d   ModuleName...
     d                         1     10

      /copy *libl/qsrcf,CB_KEYP

     d cRecordsPerPage...
     d                 c                   Const(12)
     d cEditRequest...
     d                 c                   Const('2')
     d cDeleteRequest...
     d                 c                   Const('4')
     d cDisplayRequest...
     d                 c                   Const('5')
     d cAddRecordMode...
     d                 c                   Const('A')
     d cEditRecordMode...
     d                 c                   Const('E')
     d cDisplayRecordMode...
     d                 c                   Const('D')
     d cMainProcedureName...
     d                 c                   Const('PROCESSSCREEN03')

     d g_dsRecordIn...
     d                 ds                  Qualified
     d                                     Based(ptrRecordIn)
     d                                     Dim(32766)
     d    FileName...
     d                                     Like(StdNam)
     d    LibraryName...
     d                                     Like(StdNam)
     d    Active...
     d                                     Like(StdChr)
     d    ServiceProgramName...
     d                                     Like(StdNam)
     d    ServiceProgramLibrary...
     d                                     Like(StdNam)
     d    ServiceProcedure...
     d                               50a

     d g_ProgramName...
     d                 s                   Like(StdNam)
     d                                     Import

     d g_SubfileRecordNumber...
     d                 s                   Like(StdScnRRN)
     d g_RecordsLoadedInSubfile...
     d                 s                   Like(StdScnRRN)
     d g_RecordsLoadedOnPage...
     d                 s                   Like(StdScnRRN)

     d g_ScreenOpen...
     d                 s                   Like(StdLgl)
     d                                     Inz(cFalse)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ProcessScreen03
      *   Do processing for Screen Three - Standard Single Page Load Subfile Panel.
      *   Input     - None
      *   Out       - None
      *   Returns   - Key Pressed
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ProcessScreen03...
     p                 b                   Export
     d                 pi                  Like(StdChr)

     d KeyPressed...
     d                 s                   Like(StdLgl)
      /Free

       // Build user space to hold records when we do a Fetch.
       BuildIOUserSpace();

       If Not g_ScreenOpen;
         Open TG0001_D01;
         g_ScreenOpen = cTrue;
       EndIf;

       // Default is to display first file name.
       O_CURPOSTO = *Blanks;
       B_NEWPOSTO = *Blanks;

       MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                     g_dsSystem.ModuleName:
                                     g_ProgramName        );

       LoadSubfile();

       DoU 0 = 1;

         // Display subfile messages.
         DisplaySubfileEndOnSubfileMessageQueue = cTrue;
         SFM_C_PGMQ = '*';
         Write SFMSG_CTL;

         If g_RecordsLoadedInSubfile > 0;
           DisplaySubFile = cTrue;
         Else;
           DisplaySubfile = cFalse;
           Write SF_BLANK;
         EndIf;
         DisplaySubFileControl = cTrue;

         Write RD01_03O;
         ExFmt RD01_03C;

         MSGF_ClearProgramMessageQueue(cMainProcedureName   :
                                       g_dsSystem.ModuleName:
                                       g_ProgramName        );
         Clear ErrorIndicators;

         DisplaySubfile        = cFalse;
         DisplaySubfileControl = cFalse;

         Select;
           When g_dsFileInformation01.KeyPressed = F3 or
                g_dsFileInformation01.KeyPressed = F12;
             Return g_dsFileInformation01.KeyPressed;

           // F5 = Reload screen.
           When g_dsFileInformation01.KeyPressed = F5;
             LoadSubfile();
             Iter;

           // F6 = Add Record Request.
           When g_dsFileInformation01.KeyPressed = F6;
             If ProcessScreen04(' '           :
                                ' '           :
                                cAddRecordMode) = F3;
                Return F3;
             EndIf;
             O_CURPOSTO = *Blanks;
             LoadSubfile();
             Iter;

           //Rolldown-Display previous page.
           When g_dsFileInformation01.KeyPressed = RollDown;
             LoadPreviousPage();
             Iter;

           //Rollup-Display next page.
           When g_dsFileInformation01.KeyPressed = RollUp;
             LoadOnePage();
             Iter;
           // Any other key pressed.
           Other;
             If PositionToChanged;
               O_CURPOSTO = B_NEWPOSTO;
               B_NEWPOSTO = *Blanks;
               LoadSubfile();
               Iter;
             EndIf;

             // If nothing loaded, redisplay subfile.
             If g_RecordsLoadedInSubfile <= 0;
               Iter;
             EndIf;

             //Check for options selected.
             KeyPressed = GetSelectedRecords();
             If KeyPressed = F3;
               Return F3;
             EndIf;

             If KeyPressed = F12;
               Iter;
             EndIf;

             //Call function to display screen. If nothing, will just return.
             //F12 means abort request. Redisplay screen.
             If ProcessScreen05() = F12;
               Iter;
             EndIf;

             // Else, normal end. Reload subfile.
             LoadSubfile();
             Iter;
         EndSl;
       EndDo;

       Return ' ';

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * CloseScreen03
      *   Input     - None
      *   Out       - None
      *   Returns   - None
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p CloseScreen03...
     p                 b                   Export
     d                 pi
      /Free

       Close TG0001_D01;
       g_ScreenOpen = cFalse;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadSubfile
      *   Load subfile.
      *   Input     - None
      *   Out       - None
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadSubfile...
     p                 b
     d                 pi
      /Free

       Exec Sql Declare C1 Scroll Cursor For
                  Select TDFILENAME,
                         TDLIBNAME,
                         TDACTIVE,
                         TDSRVPGM,
                         TDSRVLIB,
                         TDSRVPROC
                    From TGCTRLD
                    Where TDFILENAME >= :O_CURPOSTO
                    Order By TDFILENAME,
                             TDLIBNAME;

       Exec Sql Close C1;

       Exec Sql Open C1;
       If SqlState <> cSqlStateOk;
         ERRH_Throw('CPF9898'                 :
                    cCPFMessageFileName       :
                    'Open of Cursor C1 failed');
       EndIf;

       ClearSubfile();
       O_CURPOSTO = LoadOnePage();

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ClearSubfile
      *   Clear Subfile.
      *   Input     - None
      *   Out       - None
      *   Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ClearSubfile...
     p                 b
     d                 pi
      /Free

       g_RecordsLoadedInSubfile = 0;

       ClearSubfileInd = cTrue;
       Write RD01_03C;
       ClearSubfileInd = cFalse;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadOnePage
      *   Load one page of subfile records.
      *     Input     - None
      *     Out       - None
      *     Returns   - Key of first record.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadOnePage...
     p                 b
     d                 pi                  Like(StdNam)

     d RecordsRead...
     d                 s                   Like(StdInt)
     d NumberToLoad...
     d                 s                   Like(StdInt)
     d x...
     d                 s                   Like(StdInt)
     d SaveFirstKey...
     d                 s                   Like(StdNam)
      /Free

       g_RecordsLoadedOnPage = 0;

       NumberToLoad = cRecordsPerPage; // SQL cannot use constant.
       Exec Sql Fetch Next
                  From C1
                  For :NumberToLoad Rows
                  Into :g_dsRecordIn;
       Select;
         When SqlState = cSqlStateNoRow;
           RecordsRead = 0;
         When SqlState <> cSqlStateOk;
           ERRH_Throw('CPF9898'                                             :
                      cCPFMessageFileName                                   :
                      'Fetch from cursor C1 failed! Sql State = ' + SqlState);
         Other;
           RecordsRead = SQLERRD(3);
       EndSl;

       SaveFirstKey = g_dsRecordIn(1).FileName;

       For x = 1 To RecordsRead;
         WriteSubfileRecord(x);
       EndFor;

       // If not EOF, check if more records.
       If RecordsRead <> cRecordsPerPage;
         DisplaySubfileEnd = cTrue;
       Else;
         Exec Sql Fetch Next
                    From C1
                    For 1 Rows
                    Into :g_dsRecordIn;
         Select;
           When SqlState = cSqlStateNoRow;
             DisplaySubfileEnd = cTrue;
           When SqlState <> cSqlStateOk;
             ERRH_Throw('CPF9898'                                             :
                        cCPFMessageFileName                                   :
                        'Fetch from cursor C1 failed! Sql State = ' + SqlState);
           Other;
             DisplaySubfileEnd = cFalse;
             Exec Sql Fetch Prior
                        From C1
                        For 1 Rows
                        Into :g_dsRecordIn;
         EndSl;
       EndIf;

       // If count of records loaded on page is zero and records in
       //  subfile is zero, then no records found to load.
       If g_RecordsLoadedOnPage = 0;
         If g_RecordsLoadedInSubfile = 0;
           MSGF_SendProgramMessage('UXV0026'                     :
                                   cXVMessageFileName            :
                                   ' '                           :
                                   cMainProcedureName   :
                                   g_dsSystem.ModuleName:
                                   g_ProgramName        );
         Else;
           // No records found to load.
           MSGF_SendProgramMessage('UXV0027'            :
                                   cXVMessageFileName   :
                                   ' '                  :
                                   cMainProcedureName   :
                                   g_dsSystem.ModuleName:
                                   g_ProgramName        );
         EndIf;
       EndIf;

       // Set position of sub-file to be last record loaded.
       H_SFPOS = g_SubfileRecordNumber;

       Return SaveFirstKey;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * LoadPreviousPage
      *   Load previous page of records. Function just gets the position
      *     too value and calls the load subfile routine.
      *     Input     - None
      *     Out       - None
      *     Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p LoadPreviousPage...
     p                 b
     d                 pi

     d RecordsBack...
     d                 s                   Like(StdInt)
      /Free

       Exec Sql Declare C2 Scroll Cursor For
                  Select TDFILENAME,
                         TDLIBNAME,
                         TDACTIVE,
                         TDSRVPGM,
                         TDSRVLIB,
                         TDSRVPROC
                    From TGCTRLD
                    Where TDFILENAME < :O_CURPOSTO
                    Order By TDFILENAME,
                             TDLIBNAME;

       Exec Sql Open C2;
       If SqlState <> cSqlStateOk;
         ERRH_Throw('CPF9898'                 :
                    cCPFMessageFileName       :
                    'Open of Cursor C2 failed! Sql State = ' + SqlState);
       EndIf;

       // Position to last row.
       Exec Sql Fetch Last
                  From C2
                  For 1 Rows
                  Into :g_dsRecordIn;
       Select;
         // When no row, we are already positioned at first row.
         When SqlState = cSqlStateNoRow;
           O_CURPOSTO = *Blanks;
           MSGF_SendProgramMessage('UXV0028'                     :
                                   cXVMessageFileName            :
                                   ' '                           :
                                   cMainProcedureName   :
                                   g_dsSystem.ModuleName:
                                   g_ProgramName        );
         When SqlState <> cSqlStateOk;
           ERRH_Throw('CPF9898'                                      :
                      cCPFMessageFileName                            :
                      'Fetch from C2 failed! Sql State = ' + SqlState);
         Other;  // Anything else and their is at least one record back so
                 //   try to get back one page.
           RecordsBack = (cRecordsPerPage - 1) * -1;
           Exec Sql Fetch Relative :RecordsBack
                      From C2
                      For 1 Rows
                      Into :g_dsRecordIn;
           Select;
             // If No Row, then we have hit beginning of file and we have to
             //   load from the beginning of the file.
             When SqlState = cSqlStateNoRow;
               O_CURPOSTO = *Blanks;
               MSGF_SendProgramMessage('UXV0028'                     :
                                       cXVMessageFileName            :
                                       ' '                           :
                                       cMainProcedureName   :
                                       g_dsSystem.ModuleName:
                                       g_ProgramName        );
             When SqlState <> cSqlStateOk;
               ERRH_Throw('CPF9898'                                      :
                          cCPFMessageFileName                            :
                          'Fetch from C2 failed! Sql State = ' + SqlState);
             Other; // Otherwise, we found enough records to load an entire
                    //   page. Get the position to value.
               O_CURPOSTO = g_dsRecordIn(1).FileName;
           EndSl;
       EndSl;

       Exec Sql Close C2;

       LoadSubfile();

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * WriteSubfileRecord
      *   Write one record to the subfile.
      *     Input     - Record number in array to write.
      *     Out       - None
      *     Returns   - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p WriteSubfileRecord...
     p                 b
     d                 pi
     d  InRecordNumber...
     d                                     Like(StdInt)
     d                                     Value
      /Free

         g_RecordsLoadedInSubfile += 1;
         g_SubfileRecordNumber     = g_RecordsLoadedInSubfile;
         g_RecordsLoadedOnPage    += 1;

         B_OPTION = *Blanks;

         O_FILENAME = g_dsRecordIn(InRecordNumber).FileName;
         O_LIBNAME  = g_dsRecordIn(InRecordNumber).LibraryName;
         O_ACTIVE   = g_dsRecordIn(InRecordNumber).Active;
         O_SRVPGM   = g_dsRecordIn(InRecordNumber).ServiceProgramName;
         O_SRVLIB   = g_dsRecordIn(InRecordNumber).ServiceProgramLibrary;
         O_SRVPROC  = %Subst(g_dsRecordIn(InRecordNumber).ServiceProcedure:
                             1                                          :
                             %Size(O_SRVPROC)                           );

         // SFLNXTCHG always off.
         SubfileNextChanged = cFalse;
         H_SFLNXTCH = SubfileNextChanged;

         Write RD01_03S;

         Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * GetSelectedRecords
      *   Get all selected records from subfile.
      *     Input     - None
      *     Out       - None
      *     Returns   - Key pressed.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p GetSelectedRecords...
     p                 b
     d                 pi                  Like(StdChr)

     d KeyPressed...
     d                 s                   Like(StdChr)
      /Free

         // Clear display delete confirmation.
         ClearSubfile05();

         KeyPressed = *Blank;
         DoU KeyPressed = F12 or
             KeyPressed = F3;
           ReadC RD01_03S;
           If %Eof(TG0001_D01);
             Leave;
           EndIf;

           // Restore indicators;
           SubfileNextChanged = H_SFLNXTCH;

           Select;
             When B_OPTION = cEditRequest;
               KeyPressed = ProcessScreen04(O_FILENAME     :
                                            O_LIBNAME      :
                                            cEditRecordMode);
             When B_OPTION = cDeleteRequest;
               WriteSubfile05(O_FILENAME:
                              O_LIBNAME );
               SubfileNextChanged = cTrue;
             When B_OPTION = cDisplayRequest;
               KeyPressed = ProcessScreen04(O_FILENAME        :
                                            O_LIBNAME         :
                                            cDisplayRecordMode);
           EndSl;

           // If previous screen request, enable SFLNXTCHG for this record.
           If KeyPressed = F12;
             SubfileNextChanged = cTrue;
           Else;
             If B_OPTION <> cDeleteRequest;
               B_OPTION = *Blanks;
             EndIf;
           EndIf;

           H_SFLNXTCH = SubfileNextChanged;

           Update RD01_03S;

           SubfileNextChanged = cFalse;

           MSGF_ClearErrorIndicators(*IN                  :
                                     cStartErrorIndicators:
                                     cEndErrorIndicators  );
         EndDo;

         Return KeyPressed;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * BuildIOUserSpace
      *   Builds User Space for using in doing SQL I/O.
      *     Input     - None
      *     Out       - None
      *     Returns   - Key pressed.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p BuildIOUserSpace...
     p                 b
     d                 pi
      /Free

       USPC_CreateUserSpace('SQLUSRSP'                           :
                            'QTEMP'                              :
                            cRecordsPerPage * %Size(g_dsRecordIn):  // Initial size.
                            cTrue                                :  // Extend
                            'SQL User Space'                     :
                            '*ALL'                               :  // Authority
                            '*YES'                               :  // Replace existing
                            5                                    :  // Pages in and out.
                            '1'                                  ); // Optimize space alignment.

       ptrRecordIn = USPC_GetPointertoUserSpace('SQLUSRSP':
                                                'QTEMP'   );

      /End-Free
     p                 e
